package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @description: 你对另一半满意吗？
 */
public class YSPScale extends BaseScale {

    public YSPScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {
        //总分
        int score = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("checkItems").equals("确实是这样")) {
                score += 1;
            } else if (jsonObject1.getString("checkItems").equals("可能是这样")) {
                score += 2;
            } else if (jsonObject1.getString("checkItems").equals("不同意也不反对")) {
                score += 3;
            } else if (jsonObject1.getString("checkItems").equals("可能不是这样")) {
                score += 4;
            } else if (jsonObject1.getString("checkItems").equals("确实不是这样")) {
                score += 5;
            }
        }

        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));

        if (score >= 0 && score <= 36) {
            resultMap.put("总分结论","您的对伴侣关系满意度很低，已经低于正常范围，您需要寻求专家的帮助，你们的关系中存在较大隐患，长期看，你们的关系出现裂痕的可能性很大。");
            resultJson.put("总分结论","您的对伴侣关系满意度很低，已经低于正常范围，您需要寻求专家的帮助，你们的关系中存在较大隐患，长期看，你们的关系出现裂痕的可能性很大。");
        } else if (score >= 37 && score <= 43) {
            resultMap.put("总分结论","您对和伴侣的关系基本是满意的，希望您继续保持，您也可以寻求专家的建议，让您和伴侣的关系得到更好的改善。");
            resultJson.put("总分结论","您对和伴侣的关系基本是满意的，希望您继续保持，您也可以寻求专家的建议，让您和伴侣的关系得到更好的改善。");
        } else if (score >= 44 && score <= 50) {
            resultMap.put("总分结论","您对和伴侣的关系是满意的，暂时无需情感专家的帮助。");
            resultJson.put("总分结论","您对和伴侣的关系是满意的，暂时无需情感专家的帮助。");
        }


        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_YSP);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }
}
